Package org.jfree.layouting.renderer

## Interface Renderer

- All Superinterfaces:
    `StatefullComponent`
  All Known Implementing Classes:
    `AbstractRenderer`, `ChainingRenderer`, `PaginatingRenderer`, `PrintingRenderer`, `PrototypeBuildingRenderer`, `StreamingRenderer`

      public interface Renderer
      extends StatefullComponent

  The renderer is the last step in the predefined processing chain. The renderer computes the layout according to the style rules given in the elements and the inherent limitations of the output targets.

  Renderers depend heavily on a correct input model - at this point no model transformation should be done at all (except, maybe, inserting new lineboxes where needed).

  Contents for the page or special areas (@footnote, @endnote) are forwarded immediatly.
  Author:
    Thomas Morgner

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `addContent​(LayoutContext context, ContentToken content)` |
    `void` | `addPassThroughContent​(LayoutContext context, ContentToken content)` |
    `void` | `finishedBlock​()` |
    `void` | `finishedDocument​()` |
    `void` | `finishedFlow​()` |
    `void` | `finishedInline​()` |
    `void` | `finishedMarker​()` |
    `void` | `finishedPassThrough​()` |
    `void` | `finishedRootInline​()` |
    `void` | `finishedTable​()` |
    `void` | `finishedTableCaption​()` |
    `void` | `finishedTableCell​()` |
    `void` | `finishedTableColumn​()` |
    `void` | `finishedTableColumnGroup​()` |
    `void` | `finishedTableRow​()` |
    `void` | `finishedTableSection​()` |
    `void` | `handlePageBreak​(PageContext pageContext)` | A call-back that informs the renderer, that a new page must be started.
    `void` | `startedBlock​(LayoutContext context)` |
    `void` | `startedDocument​(PageContext pageContext)` | Starts the document and initalizes the default page context.
    `void` | `startedFlow​(LayoutContext context)` | Starts a floating, absolute or static element.
    `void` | `startedInline​(LayoutContext context)` |
    `void` | `startedMarker​(LayoutContext context)` |
    `void` | `startedPassThrough​(LayoutContext context)` |
    `void` | `startedRootInline​(LayoutContext context)` |
    `void` | `startedTable​(LayoutContext layoutContext)` |
    `void` | `startedTableCaption​(LayoutContext context)` |
    `void` | `startedTableCell​(LayoutContext layoutContext)` |
    `void` | `startedTableColumn​(LayoutContext context)` |
    `void` | `startedTableColumnGroup​(LayoutContext context)` |
    `void` | `startedTableRow​(LayoutContext layoutContext)` |
    `void` | `startedTableSection​(LayoutContext layoutContext)` |

    - ### Methods inherited from interface org.jfree.layouting.StatefullComponent

      `saveState`

- - ### Method Detail

    - #### startedDocument

          void startedDocument​(PageContext pageContext)

      Starts the document and initalizes the default page context.
      Parameters:
        `pageContext` -

    - #### startedFlow

          void startedFlow​(LayoutContext context)
                    throws NormalizationException

      Starts a floating, absolute or static element. This establishes a new normal flow for the element.
      Parameters:
        `context` -
      Throws:
        `NormalizationException`

    - #### startedTable

          void startedTable​(LayoutContext layoutContext)
                     throws NormalizationException

      Throws:
        `NormalizationException`

    - #### startedTableColumnGroup

          void startedTableColumnGroup​(LayoutContext context)
                                throws NormalizationException

      Throws:
        `NormalizationException`

    - #### startedTableColumn

          void startedTableColumn​(LayoutContext context)
                           throws NormalizationException

      Throws:
        `NormalizationException`

    - #### startedTableSection

          void startedTableSection​(LayoutContext layoutContext)
                            throws NormalizationException

      Throws:
        `NormalizationException`

    - #### startedTableRow

          void startedTableRow​(LayoutContext layoutContext)
                        throws NormalizationException

      Throws:
        `NormalizationException`

    - #### startedTableCell

          void startedTableCell​(LayoutContext layoutContext)
                         throws NormalizationException

      Throws:
        `NormalizationException`

    - #### startedBlock

          void startedBlock​(LayoutContext context)
                     throws NormalizationException

      Throws:
        `NormalizationException`

    - #### startedMarker

          void startedMarker​(LayoutContext context)
                      throws NormalizationException

      Throws:
        `NormalizationException`

    - #### startedRootInline

          void startedRootInline​(LayoutContext context)
                          throws NormalizationException

      Throws:
        `NormalizationException`

    - #### startedInline

          void startedInline​(LayoutContext context)
                      throws NormalizationException

      Throws:
        `NormalizationException`

    - #### addContent

          void addContent​(LayoutContext context,
                          ContentToken content)
                   throws NormalizationException

      Throws:
        `NormalizationException`

    - #### finishedInline

          void finishedInline​()
                       throws NormalizationException

      Throws:
        `NormalizationException`

    - #### finishedRootInline

          void finishedRootInline​()
                           throws NormalizationException

      Throws:
        `NormalizationException`

    - #### finishedMarker

          void finishedMarker​()
                       throws NormalizationException

      Throws:
        `NormalizationException`

    - #### finishedBlock

          void finishedBlock​()
                      throws NormalizationException

      Throws:
        `NormalizationException`

    - #### finishedTableCell

          void finishedTableCell​()
                          throws NormalizationException

      Throws:
        `NormalizationException`

    - #### finishedTableRow

          void finishedTableRow​()
                         throws NormalizationException

      Throws:
        `NormalizationException`

    - #### finishedTableSection

          void finishedTableSection​()
                             throws NormalizationException

      Throws:
        `NormalizationException`

    - #### finishedTableColumnGroup

          void finishedTableColumnGroup​()
                                 throws NormalizationException

      Throws:
        `NormalizationException`

    - #### finishedTableColumn

          void finishedTableColumn​()
                            throws NormalizationException

      Throws:
        `NormalizationException`

    - #### finishedTable

          void finishedTable​()
                      throws NormalizationException

      Throws:
        `NormalizationException`

    - #### finishedFlow

          void finishedFlow​()
                     throws NormalizationException

      Throws:
        `NormalizationException`

    - #### finishedDocument

          void finishedDocument​()
                         throws NormalizationException

      Throws:
        `NormalizationException`

    - #### handlePageBreak

          void handlePageBreak​(PageContext pageContext)

      A call-back that informs the renderer, that a new page must be started. This closes the old page context and copies all pending content to the new context.

      This method is triggered by a call to 'LayoutProcess.pageBreakEncountered'
      Parameters:
        `pageContext` -

    - #### startedPassThrough

          void startedPassThrough​(LayoutContext context)
                           throws NormalizationException

      Throws:
        `NormalizationException`

    - #### addPassThroughContent

          void addPassThroughContent​(LayoutContext context,
                                     ContentToken content)
                              throws NormalizationException

      Throws:
        `NormalizationException`

    - #### finishedPassThrough

          void finishedPassThrough​()
                            throws NormalizationException

      Throws:
        `NormalizationException`

    - #### startedTableCaption

          void startedTableCaption​(LayoutContext context)
                            throws NormalizationException

      Throws:
        `NormalizationException`

    - #### finishedTableCaption

          void finishedTableCaption​()
                             throws NormalizationException

      Throws:
        `NormalizationException`